/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.toolkit.SqlHelper;
import org.springblade.community.entity.Residential;
import org.springblade.community.vo.ResidentialVO;
import org.springblade.community.mapper.ResidentialMapper;
import org.springblade.community.service.IResidentialService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.mp.support.Query;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.transaction.annotation.Transactional;

import java.sql.Wrapper;
import java.util.List;

/**
 * 小区表，新建小区的时候，小区也要作为一个机构存入到机构表里面，机构的编号就使用当前小区的编号 服务实现类
 *
 * @author BladeX
 * @since 2021-03-29
 */
@Service
public class ResidentialServiceImpl extends BaseServiceImpl<ResidentialMapper, Residential> implements IResidentialService {

	@Override
	public IPage<ResidentialVO> selectResidentialPage(IPage<ResidentialVO> page, ResidentialVO residential) {
		return page.setRecords(baseMapper.selectResidentialPage(page, residential));
	}

	@Override
	@Transactional
	public boolean saveOrUpdateResidential(Residential residential) {
		if(residential.getId() == null && !this.save(residential)){
			return false;
		}
		residential.setOrgPosition(residential.getOrgPosition()+"/"+residential.getId());
		return this.updateById(residential);
	}

	@Override
	public List<ResidentialVO> findPage(Long current, Long size, String agencyId, String name) {
		return baseMapper.findPage(current,size,agencyId,name);
	}

	@Override
	public List<Residential> getListWithYtelevatorXq(List<Long> residentialIds) {
		QueryWrapper<Residential> queryWrapper = new QueryWrapper<>();
		queryWrapper.in("id", residentialIds);
		return baseMapper.selectList(queryWrapper);
	}

	@Override
	public Boolean delete(Long id) {
		return baseMapper.delete(id);
	}

}
